.NOLIST
.486
.model flat, stdcall  ; 32 bit memory model
option casemap :none  ; case sensitive

include    \sdkrc7\translate.inc
include      \sdkrc7\unknwn.sdk
include   colib.inc

PUBLIC g_ObjectCount
PUBLIC IID_IClassFactory       
PUBLIC IID_IDispatch
PUBLIC IID_IUnknown
.const

IClassFactory_Interface STRUCT
			ppv dd  ?			;must be the first
			stsize dd ?	
			StartList dd ?	
			count dd ?	
			;---------------
			temoin db "IClassFactory",0				
IClassFactory_Interface ENDS   

EXTERNDEF Liste_CLSID:DWORD



.data
IClassFactory_Vtbl  	dd Colib_QueryInterface
				dd Colib_AddRef
				dd Colib_Release
				;---------- end IUnknown ----------------			
				dd Colib_CreateInstance
 				dd Colib_LockServer

Interface_IClassFactory IClassFactory_Interface <IClassFactory_Vtbl,sizeof Interface_IClassFactory,,>

;define the ppvIClassFactory to use with the macro
IID_IClassFactory GUID sIID_IClassFactory
IID_IUnknown GUID sIID_IUnknown	
g_ObjectCount dd 0
IID_IDispatch           GUID            sIID_IDispatch
.code
DllGetClassObject PROC uses esi edi rclsid:DWORD, riid:DWORD, ppv:DWORD
	local ppvIClassFactory:DWORD
             
;-------------------------------------------------------------------------------
; COM server dll main export
; EXAMPLE:
;   invoke DllGetClassObject, ADDR clsid, ADDR iid:DWORD, ADDR pv
; Uses: eax, ecx, edx
;
;
;-------------------------------------------------------------------------------
	;invoke DebugBreak
	;invoke MessageBox,NULL,ADDR szDllGetClassObject,addr sztitre,MB_OK
	mov esi,Liste_CLSID ;esi point on the adress of the list of interfaces
	mov eax,[esi]
	@@:
	add esi,4	
	invoke IsEqualGUID,rclsid,esi
	.if eax == 0		;not egal
		add esi,sizeof GUID
		.if dword ptr [esi] == 0   ;end of CLSID list
			mov eax,CLASS_E_CLASSNOTAVAILABLE
			jmp FindeDllGetClassObject
		.else
			jmp @B
		.endif
	.endif
	;we find the CLSID
	;------- get the interfaces list -------------------
	sub esi,4
	mov esi,[esi]		;get the addres of list of interfaces
	;crer la IClassFactory pour ce CLSID	
	invoke CoTaskMemAlloc, sizeof Interface_IClassFactory
	.if eax == 0
		mov eax,E_OUTOFMEMORY
		jmp FindeDllGetClassObject		
	.endif
	mov ecx,sizeof Interface_IClassFactory
	mov edi,eax	
	mov ppvIClassFactory,eax
	;initialise the com mem
	push edi
	push esi
	lea esi,Interface_IClassFactory
	rep movsb
	pop esi
	pop edi
	;sauvegarde l'adresse des interfaces pour ce clsid
	mov [edi].START.StartList,esi	
	IClassFactory AddRef
	invoke IsEqualGUID,riid,addr IID_IClassFactory
	.if eax == 1
		mov esi,ppv
		mov [esi],edi
		mov eax,S_OK
		jmp FindeDllGetClassObject
	.endif
	IClassFactory QueryInterface,riid,ppv		
	push eax
	IClassFactory Release		
	pop eax
	FindeDllGetClassObject:
    ret
DllGetClassObject ENDP
;-------------------------------------------------------------------------------



;----------------------- Iunknown -----------------------------------
Colib_QueryInterface PROC uses esi edi this_:DWORD,pIID:DWORD,  ppv:DWORD
       local ppvIUnknown :DWORD  
	;demand par la definition de la fonction
	;si pIID = Iunknown,retourn le mme pointeur
	invoke IsEqualGUID,pIID,addr 	IID_IUnknown
	.if eax == 1
		mov eax,this_
		mov ppvIUnknown,eax
		mov edi,ppv
		mov [edi],eax
		IUnknown AddRef
		mov eax,S_OK
		jmp FindeQueryInterface
	.endif
	;---------------- recherche normal -----------------------  
	mov esi, this_                                ; get object
	mov edi,[esi].START.StartList
	@@:
	add edi,4	
	invoke IsEqualGUID,pIID,edi
	.if eax == 0		;not egal
		add edi,sizeof GUID
		.if dword ptr [edi] == 0   ;end of CLSID list
			mov edi,ppv
			mov dword ptr [edi],0
			mov eax,E_NOINTERFACE
			jmp FindeQueryInterface
		.else
			jmp @B
		.endif
	.endif 
	;------- IID found ------------
	sub edi,4
	mov esi,[edi]		;esi pointe interface data
	;rcupre la taille du bloc mmoire a crer
	mov edx,[esi].START.stsize
	invoke CoTaskMemAlloc, edx
	.if eax == 0
		mov eax,E_OUTOFMEMORY
		jmp FindeQueryInterface		
	.endif
	mov edi,eax		
	mov ecx,[esi].START.stsize
	;initialise the com mem
	push edi
	push esi
	rep movsb
	pop esi
	pop edi
	;sauvegarde l'adresse des interfaces pour ce clsid
	mov esi,ppv
	mov [esi],edi		;passe le pointeur d'interface demand
	mov ppvIUnknown,edi
	IUnknown AddRef
	mov eax,S_OK	
	
FindeQueryInterface:	   	
    ret
Colib_QueryInterface ENDP



;-------------------------------------------------------------------------------

Colib_AddRef  PROC this_:DWORD             
     mov ecx, this_                              ; get object
     inc dword ptr [ecx].START.count     ; count +1
     mov eax,[ecx].START.count
     ret
Colib_AddRef  ENDP
;-------------------------------------------------------------------------------

Colib_Release PROC  this_:DWORD
             
    mov edx, this_                                ; get object
    dec dword ptr [edx].START.count
    mov eax,[edx].START.count

    .if eax == 0
	invoke CoTaskMemFree,this_
	mov eax,0
    .endif	 	
    ret
Colib_Release ENDP

Colib_CreateInstance PROC  this_:DWORD, pUnkOuter:DWORD, iid:DWORD, ppv:DWORD
	local ppvIUnknown :DWORD 
             
;-------------------------------------------------------------------------------
; implimentation of the IClassFactory::CreateInstance method
;
;-------------------------------------------------------------------------------
	.if pUnkOuter	!= 0
		mov edx,ppv
		mov dword ptr [edx],0
		mov eax,CLASS_E_NOAGGREGATION
		jmp return
	.endif
	mov edx, this_                                  ; get object
	mov ppvIUnknown,edx
	IUnknown QueryInterface, iid, ppv
return:
    ret
Colib_CreateInstance ENDP
;-------------------------------------------------------------------------------

;-------------------------------------------------------------------------------

Colib_LockServer PROC this_:DWORD, bLockServer:DWORD
             
;-------------------------------------------------------------------------------
; implimentation of the IClassFactory::LockServer method
;-------------------------------------------------------------------------------
	mov eax,this_
    .IF bLockServer == TRUE
        inc g_ObjectCount          ; increase the global lock count
                                   ;  doubles as lock count too
    .ELSE
        dec g_ObjectCount          ; decrease the global lock count
    .ENDIF
    mov eax, S_OK
    ret
Colib_LockServer ENDP
;-------------------------------------------------------------------------------



end
