;-------------------------------------------------------------------------------
;  colibrary procedure Register_Typelib
;
; -------------------------------------------------------
; This procedure was written by Ernest Murphy    9/27/00
;
; Copyright (c) 9/28/00  Ernest Murphy
; For educational use only. Any commercial re-use only by written license
;
; -------------------------------------------------------
.NOLIST
.486
.model flat, stdcall  ; 32 bit memory model
option casemap :none  ; case sensitive


include    \sdkrc7\translate.inc
include      \sdkrc7\unknwn.sdk
include     \masm32\include\masm32.inc
include \masm32\macros\macros.asm
include     colib.inc

externdef   g_hHeap:DWORD
externdef   g_hModule:DWORD
IDS_TypeLib   equ    203

comment 
The function RegisterTypeLib can be used during application initialization to register the 
application's type library correctly. When RegisterTypeLib is called to register a type library,
both the minor and major version numbers are registered in hexadecimal.
In addition to filling in a complete registry entry under the type library key, RegisterTypeLib
adds entries for each of the dispinterfaces and Automation-compatible interfaces, 
including dual interfaces. This information is required to create instances of these interfaces.
			**Coclasses**  are not registered 
**Coclasses** are not registered (that is, RegisterTypeLib does not write any values to the
 CLSID key of the coclass). 


.code
;-------------------------------------------------------------------------------

Register_Typelib PROC PUBLIC
		
;-------------------------------------------------------------------------------
; This function use the API RegisterTypeLib who need many informations   
;
; EXAMPLE:
;   invoke Register_Typelib
;
; Uses: eax, ecx, edx
;
;
;-------------------------------------------------------------------------------
	LOCAL rCount:DWORD,         hres:DWORD;,         pResEnd:DWORD
	LOCAL psCount:DWORD,        psBuf:DWORD,        pwsBuf:DWORD
	LOCAL szTypeLib[20]:BYTE
	LOCAL   ppvITypeLib:DWORD	,	cnt:dword
	LOCAL tempId:DWORD,retour    
	ZEROLOCALES retour
   
	invoke HeapAlloc, g_hHeap,HEAP_ZERO_MEMORY, ( MAX_PATH * 4 + 20)
	mov psBuf, eax
	add eax, MAX_PATH * 2
	mov pwsBuf, eax
	add eax, 10
	mov psCount, eax
	mov rCount, 1           ; init the resource number to #1
	push rCount
	pop  tempId	
	xor eax,eax
	mov cnt,eax	
	mov retour,1           ;failed by defaut S_FALSE
	
	;                  get the count of Typelib
	;----- load the type (string) typelib ---------
	invoke LoadString, g_hModule,IDS_TypeLib, ADDR szTypeLib, sizeof szTypeLib
	@@:
	; find the resource 1 to N (tempId)
	invoke FindResource,g_hModule,tempId, ADDR szTypeLib
	.if eax != 0
		;------------ invoke CloseHandle,eax faute debug ------------------
		;handle of resource don't need to be closed
		inc cnt
		inc tempId
		jmp @B
	.endif
	.if cnt == 0
		invoke MessageBox,NULL,ADDR szTypeLib,ADDR TITRE008,MB_OK
		mov eax,1      ;failed	
		jmp FindeRegister_Typelib
	.endif		
	.while(cnt)		;for the number of resources
		; loop to find the resource
		invoke FindResource,g_hModule, rCount, ADDR szTypeLib
		.IF !eax
			invoke MessageBox,NULL,ADDR szTypeLib,ADDR TITRE004,MB_OK
			.break
		.ENDIF
		mov hres, eax
		invoke LoadResource, g_hModule, hres
		invoke LockResource, eax
		mov hres, eax
		mov eax, [eax]      ; get 1st 4 characters of this resource
		.IF eax != 5446534DH   ; belt-and-suspenders check to assure is TypeLib res
			; 5446534DH = "TFSM", or "MSFT backwards, check for typelib resource
			invoke MessageBox,NULL,ADDR TITRE005 ,ADDR TITRE005,MB_OK
			.break
		.ENDIF
		invoke GetModuleFileName, g_hModule, psBuf, MAX_PATH
		mov eax, psCount
		mov WORD PTR [eax], 005CH       ; "\", 0 string
		invoke lstrcat, psBuf, psCount  ; cat "\" onto FileName
		invoke dwtoa, rCount, psCount     
		invoke lstrcat, psBuf, psCount  ; cat "\####" onto FileName, where ####
						;  is the resource number in string form
		invoke MultiByteToWideChar, CP_ACP, 0, psBuf, -1, pwsBuf, MAX_PATH
		.IF !eax
			invoke MessageBox,NULL,psBuf,ADDR TITRE006,MB_OK
			.break
		.ENDIF
		invoke LoadTypeLib, pwsBuf,addr ppvITypeLib
		.IF (eax != ERROR_SUCCESS)
			invoke MessageBox,NULL,psBuf,ADDR TITRE007,MB_OK
			.break
		.ENDIF
		; and register the type lib
		invoke GetModuleFileName,g_hModule, psBuf, MAX_PATH
		invoke MultiByteToWideChar, CP_ACP, 0, psBuf, -1, pwsBuf, MAX_PATH
		
		invoke RegisterTypeLib, ppvITypeLib, pwsBuf, NULL
		.IF (eax != ERROR_SUCCESS)
			invoke MessageBox,NULL,pwsBuf,ADDR TITRE000,MB_OK
			ITypeLib Release
			.break
		.ELSE
			; release the type info pointer we got
			ITypeLib Release
		.ENDIF
		inc rCount
		dec cnt
		.if cnt == 0
			mov retour,0	;OK
		.endif
	.ENDW
	; clean up our buffers
	invoke HeapFree, g_hHeap, NULL, psBuf        
	FindeRegister_Typelib:
	mov eax,retour
	ret
Register_Typelib ENDP
;-------------------------------------------------------------------------------

UnRegister_TypeLib PROC PUBLIC
		
;-------------------------------------------------------------------------------
; COM server dll main export
;   Unregisters a component from the registry
;   
;
; EXAMPLE:
;   invoke UnRegister_TypeLib
;
; Uses: eax, ecx, edx
;
;
;-------------------------------------------------------------------------------
	LOCAL rCount:DWORD,         hres:DWORD;,         pResEnd:DWORD
	LOCAL psCount:DWORD,        psBuf:DWORD,        pwsBuf:DWORD
	LOCAL szTypeLib[20]:BYTE
	LOCAL   ppvITypeLib:DWORD,          pTLibAttr:DWORD 
	LOCAL m_MajorVer:DWORD,     m_MinorVer:DWORD 
	LOCAL m_lcid:DWORD,         m_syskind:DWORD ,	cnt:dword
	LOCAL tempId:DWORD,retour
	ZEROLOCALES retour

	; make some strings
	invoke HeapAlloc, g_hHeap, NULL, ( MAX_PATH * 3 + 10)
	mov psBuf, eax
	add eax, MAX_PATH * 2
	mov pwsBuf, eax
	add eax, 10
	mov psCount, eax
	mov rCount, 1           ; init the resource number to #1
	push rCount
	pop tempId
	xor eax,eax
	mov cnt,eax

	mov retour,1		;failed by defaut
	
		    
	invoke LoadString, g_hModule, IDS_TypeLib, ADDR szTypeLib, 20
	; get the count of typelib
	@@:
	invoke FindResource,g_hModule,tempId, ADDR szTypeLib
	.if eax != 0
		;invoke CloseHandle,eax faux debug 
		inc cnt
		inc tempId
		jmp @B
	.endif
	.if cnt == 0
		invoke MessageBox,NULL,ADDR szTypeLib,ADDR TITRE008,MB_OK
		mov eax,1
		jmp FindeUnRegister_TypeLib				
	.endif
	;  ++++++++++++     loop to find the resource		+++++++++++
	.while(cnt)   
		invoke FindResource,g_hModule, rCount, ADDR szTypeLib
		.IF !eax
			invoke MessageBox,NULL,ADDR szTypeLib,ADDR TITRE004,MB_OK
			.break
		.ENDIF
		mov hres, eax
		invoke LoadResource, g_hModule, hres
		invoke LockResource, eax
		mov hres, eax
		mov eax, [eax]                  ; get 1st 4 characters of this resource
		.IF eax != 5446534DH            ; ew-check to assure is TypeLib resource
						; 5446534DH = "TFSM", or "MSFT" backwards
			invoke MessageBox,NULL,ADDR TITRE005 ,ADDR TITRE005,MB_OK
			.break
		.ENDIF
		invoke GetModuleFileName, g_hModule, psBuf, MAX_PATH
		mov eax, psCount
		mov ecx, 0000005CH
		mov [eax], ecx
		invoke lstrcat, psBuf, psCount  ; cat "\" onto FileName
		invoke dwtoa, rCount, psCount
		invoke lstrcat, psBuf, psCount  ; cat "\####" onto FileName, where ####
						;  is the resource number in string form
		invoke MultiByteToWideChar, CP_ACP, 0, psBuf, -1, pwsBuf, MAX_PATH
		.IF !eax
			invoke MessageBox,NULL,psBuf,ADDR TITRE006,MB_OK
			.break 
		.ENDIF
		invoke LoadTypeLib, pwsBuf, ADDR ppvITypeLib
		.if eax != S_OK
			invoke MessageBox,NULL,psBuf,ADDR TITRE007,MB_OK
			.break
		.ENDIF
		mov pTLibAttr, 0
		lea ecx,pTLibAttr
		ITypeLib GetLibAttr,ecx
		.if eax != S_OK
			ITypeLib Release
			.break
		.ENDIF
		comment 
modifier oaidl.sdk     guid GUID <> and not dword
TLIBATTR	STRUCT
	guid GUID ?
	lcid DWORD ?
	syskind DWORD ?
	wMajorVerNum WORD ?
	wMinorVerNum WORD ?
	wLibFlags WORD ?
TLIBATTR		ENDS


		mov ecx, pTLibAttr
		xor eax, eax
		mov ax, (TLIBATTR PTR [ecx]).wMajorVerNum
		mov m_MajorVer, eax
		mov ax, (TLIBATTR PTR [ecx]).wMinorVerNum 
		mov m_MinorVer, eax 
		mov eax, (TLIBATTR PTR [ecx]).lcid
		mov m_lcid, eax 
		mov eax, (TLIBATTR PTR [ecx]).syskind
		mov m_syskind, eax
		mov ecx, pTLibAttr
		invoke UnRegisterTypeLib, ecx, m_MajorVer, m_MinorVer, m_lcid, m_syskind
		push eax
		ITypeLib ReleaseTLibAttr, pTLibAttr
		ITypeLib Release		
		pop eax
		.if eax != S_OK	
			invoke MessageBox,NULL,ADDR TITRE009,ADDR TITRE009,MB_OK
			.break
		.endif	
		; now try for the next typelib
		inc rCount
		dec cnt
		.if cnt == 0
			mov retour,0	;OK
		.endif
	.ENDW

	; clean up our buffers
	invoke HeapFree, g_hHeap, NULL, psBuf   
FindeUnRegister_TypeLib: 
	mov eax,retour    
	ret
UnRegister_TypeLib ENDP
;-------------------------------------------------------------------------------



end
